LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY part5 IS
	PORT ( SW : IN STD_LOGIC_VECTOR(9 DOWNTO 0);
			LEDR : OUT STD_LOGIC_VECTOR(9 DOWNTO 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6)	);
END part5;

ARCHITECTURE Behavior OF part5 IS
	COMPONENT mux_2bit_4to1
	PORT ( s,u,v,w,x : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
			 y : OUT STD_LOGIC_VECTOR(1 DOWNTO 0));
	END COMPONENT;

	COMPONENT char_7seg
	PORT ( C : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
			 HEX : OUT STD_LOGIC_VECTOR(0 TO 6));
	END COMPONENT;
	
   SIGNAL M0, M1, M2, M3 : STD_LOGIC_VECTOR(1 DOWNTO 0);
	
BEGIN
   
	LEDR <= SW;
	
	U0: mux_2bit_4to1 
	PORT MAP ( SW(9 DOWNTO 8), SW(1 DOWNTO 0), SW(3 DOWNTO 2), SW(5 DOWNTO 4), SW(7 DOWNTO 6), M0);
   H0: char_7seg PORT MAP (M0, HEX0);
	
	U1: mux_2bit_4to1 
	PORT MAP ( SW(9 DOWNTO 8), SW(3 DOWNTO 2), SW(5 DOWNTO 4), SW(7 DOWNTO 6), SW(1 DOWNTO 0), M1);
   H1: char_7seg PORT MAP (M1, HEX1);
	
	U2: mux_2bit_4to1 
	PORT MAP ( SW(9 DOWNTO 8), SW(5 DOWNTO 4), SW(7 DOWNTO 6), SW(1 DOWNTO 0), SW(3 DOWNTO 2), M2);
   H2: char_7seg PORT MAP (M2, HEX2);
	
	U3: mux_2bit_4to1 
	PORT MAP ( SW(9 DOWNTO 8), SW(7 DOWNTO 6), SW(1 DOWNTO 0), SW(3 DOWNTO 2), SW(5 DOWNTO 4), M3);
   H3: char_7seg PORT MAP (M3, HEX3);
	 

END Behavior;


