LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY part6 IS
	PORT ( SW : IN STD_LOGIC_VECTOR(9 DOWNTO 0);
			LEDR : OUT STD_LOGIC_VECTOR(9 DOWNTO 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX4 : OUT STD_LOGIC_VECTOR(0 TO 6);
			HEX5 : OUT STD_LOGIC_VECTOR(0 TO 6)	);
END part6;

ARCHITECTURE Behavior OF part6 IS
	COMPONENT mux_2bit_6to1
	PORT ( x1, x2, x3, x4, x5, x6 : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
			 sel : in STD_LOGIC_VECTOR(2 DOWNTO 0);
			 y : OUT STD_LOGIC_VECTOR(1 DOWNTO 0));
	END COMPONENT;

	COMPONENT char_7seg
	PORT ( C : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
			 HEX : OUT STD_LOGIC_VECTOR(0 TO 6));
	END COMPONENT;
	
   SIGNAL M0, M1, M2, M3, M4, M5 : STD_LOGIC_VECTOR(1 DOWNTO 0);
	SIGNAL S0, S1, S2, S3, S4, s5 : STD_LOGIC_VECTOR(2 DOWNTO 0);
	CONSTANT blank : std_logic_vector(1 downto 0) := "11";
	CONSTANT D : std_logic_vector(1 downto 0) := "00";
	CONSTANT E : std_logic_vector(1 downto 0) := "01";
	CONSTANT U : std_logic_vector(1 downto 0) := "10";
	
BEGIN
   
	LEDR <= SW;
	
	U0: mux_2bit_6to1 
	PORT MAP ( blank, 	blank, 	blank, D, 		E, 		U, 	SW(9 downto 7), M0);
   H0: char_7seg PORT MAP (M0, HEX0);
	
	U1: mux_2bit_6to1 
	PORT MAP ( U, 			blank, 	blank, blank,  D, 		E, 	SW(9 downto 7), M1);
   H1: char_7seg PORT MAP (M1, HEX1);
	
	U2: mux_2bit_6to1 
	PORT MAP ( E, 			U, 		blank,  blank, blank, 	D, 	SW(9 downto 7), M2);
   H2: char_7seg PORT MAP (M2, HEX2);
	
	U3: mux_2bit_6to1 
	PORT MAP ( D, 			E, 		U, 	  blank, blank, 	blank, SW(9 downto 7), M3);
   H3: char_7seg PORT MAP (M3, HEX3);
	
	U4: mux_2bit_6to1 
	PORT MAP ( blank, 	D, 		E, 	  U, 		blank,   blank, SW(9 downto 7), M4);
   H4: char_7seg PORT MAP (M4, HEX4);
	
	U5: mux_2bit_6to1 
	PORT MAP ( blank, 	blank,	D,		  E, 	   U, 		blank, SW(9 downto 7), M5);
   H5: char_7seg PORT MAP (M5, HEX5);	
	

END Behavior;


